//-----------------------------------------------------------------------------
// Purpose: Writes all useful weapon data (maxammo, name, etc) to weapon's scope
//			The function "WriteTableToScope()" is actually under "_tables.nut" in class TF_WEAPONS_BASE
//-----------------------------------------------------------------------------


::GTFW.WriteTableToWeaponScope <- function(player, wep)
{
	if ( type( player ) != "instance" ) return;
	if ( type( wep ) != "instance" ) return;
	
	wep.ValidateScriptScope();
	local wep_scope = wep.GetScriptScope();
	if ( "tf_class" in wep_scope ) return GTFW.DevPrint(0,"WriteTableToWeaponScope", "GTFW Table already in scope of \x22"+wep+"\x22.");
	
	local table = player.GetWeaponTable(wep);
	
	GTFW.DevPrint(0,"WriteTableToWeaponScope", "Writing GTFW table to scope of \x22"+wep+"\x22");
	table.WriteTableToScope(wep_scope);
}


::GTFW.WriteTableToWeaponScope_EntireLoadout <- function(player=null)
{
//Error if param is null
	if ( player == null || type(player) != "instance" ) {
		GTFW.DevPrint(1,"WriteTableToWeaponScope_EntireLoadout", "Function failed. Parameter is null. Returning null.")
		return null
	}
	
	local AllWeaponsArray = player.GetAllWeapons();
	
	foreach(k, wep in AllWeaponsArray)
		GTFW.WriteTableToWeaponScope(player, wep);
	
	GTFW.DevPrint(0,"WriteTableToWeaponScope_EntireLoadout", "Finished writing to loadout.");
}