
IncludeScript("sprinklesscripts/lib/sprinkles_util.nut")
IncludeScript("give_tf_weapon/_master.nut")

DisableRespawnLoadout <- false;

Mystery_box_model <- EntityGroup[0];
Mystery_box_weapon_model <- EntityGroup[1];
Mystery_box_button <- EntityGroup[2];

m_iRollingDecel <- 0;
m_hButtonCaller <- null;
m_bEnableRolling <- false;
m_bEnableDecay <- false;
m_bEnableDecayAnimation <- false;
m_flRollingTime <- Time();
m_flRollingTimePickDelay <- Time();
m_flDecayTimer <- Time();
m_flDecayTimerAnimation <- Time();
m_aPickedArray <- [];

m_hFakeProp <- null;

::QuadShooter <- function(weapon, player)
{
	weapon.AddAttribute("damage bonus", 1.5, -1)
	weapon.AddAttribute("Projectile speed increased", 1.5, -1)
	weapon.AddAttribute("Blast radius decreased", 0.5, -1)
	weapon.AddAttribute("faster reload rate", 0.8, -1)

	if( weapon.ValidateScriptScope() )
	{
		local weaponscope = weapon.GetScriptScope()
		weaponscope["WeaponThink"] <- function()	//Our script's name under the weapon scope.
		{
			local owner = self.GetOwner()

			for (local entity; entity = Entities.FindByClassname(entity, "tf_projectile_rocket");)
			{
				if ((entity.GetModelName() == "models/weapons/w_models/w_rocket.mdl") && (GetPropEntity(entity, "m_hLauncher") == weapon))
				{
					//SetPropString(entity, "m_iClassname", "megaton")
					entity.SetModel("models/buildables/sentry3_rockets.mdl")
					entity.SetSize(GRENADE_SIZE_VECT_MIN, GRENADE_SIZE_VECT_MAX)
					break;
				}
			}

			return -1
		}
		AddThinkToEnt(weapon, "WeaponThink")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
	}

}

::TauCannon <- function(weapon, player)
{
	weapon.AddAttribute("fire rate bonus", 0.5, -1)
	weapon.AddAttribute("override projectile type", 1, -1)
	weapon.AddAttribute("damage causes airblast", 1, -1)
	weapon.AddAttribute("dmg pierces resists absorbs", 1, -1)
	weapon.AddAttribute("crit mod disabled", 0.0, -1)
	weapon.AddAttribute("stickybomb charge rate", 0.5, -1)
	weapon.AddAttribute("sniper fires tracer", 1, -1)

	if( weapon.ValidateScriptScope() )
	{
		local weaponscope = weapon.GetScriptScope()
		weaponscope.m_bInReload <- false;
		weaponscope.last_fire_time <- 0.0;
		weaponscope.RefreshTime <- 0.0
		weaponscope.m_flChargeTime <- 0.0
		weaponscope.m_flChargeAmount <- 0.0
		//SetPropBool(weapon, "m_bReloadsSingly", false)
		weaponscope["WeaponThink"] <- function()	//Our script's name under the weapon scope.
		{
			local owner = self.GetOwner()

			if (GetPropFloat(self, "m_flChargeBeginTime") != 0)
			{
				local m_flMaxChargeTime = 3.9 * self.GetAttribute("stickybomb charge rate", 1.0)
				local m_flChargeBeginTime = GetPropFloat(self, "m_flChargeBeginTime")
				m_flChargeAmount = Time() - (m_flChargeBeginTime + 0.01)
				m_flChargeTime = RemapVal( m_flChargeAmount,  0.0,  m_flMaxChargeTime,  0.125,  2.5)
				if (m_flChargeAmount >= (3.96 * self.GetAttribute("stickybomb charge rate", 1.0)))
				{
					printf("%f %s : Exploded!\n", Time(), self.GetClassname())
					m_flChargeAmount = 0.0
					weapon.AddAttribute("damage penalty", m_flChargeTime, -1)
					weapon.AddAttribute("bullets per shot bonus", 0.0, -1)
					EmitSoundEx({
						sound_name = "BaseExplosionEffect.Sound",
						origin = owner.GetCenter(),
						pitch = RandomInt(94, 110),
						volume = RandomFloat(0.8, 1),
						sound_level = 155,
						entity = self,
					});

					DispatchParticleEffect("mvm_loot_explosion", owner.GetOrigin(), Vector())

					local Explode = SpawnEntityFromTable("env_explosion", {
						spawnflags = 4 + 8 + 32 + 64 + 256 + 512,
						iMagnitude = 100,
						iRadiusOverride = 192,
						origin = owner.GetCenter()
					})

					SetPropString(Explode, "m_iClassname", "pumpkindeath")

					Explode.SetOwner(owner)
					Explode.AcceptInput("Explode", "", null, null)
					Explode.Destroy()
					return 0.4;
				}
				else
				{
					weapon.AddAttribute("damage penalty", m_flChargeTime, -1)
				}
			}

			local fire_time = NetProps.GetPropFloat(self, "m_flLastFireTime")
			if (fire_time > last_fire_time)
			{
				printf("%f %s : Fired\n", Time(), self.GetClassname())
				printf("%f : m_flChargeAmount\n", m_flChargeAmount)

				local owner = self.GetOwner()
				if (owner)
				{
					weapon.AddAttribute("bullets per shot bonus", 1.0, -1)
					owner.SetAbsVelocity(owner.GetAbsVelocity() - owner.EyeAngles().Forward() * (600.0 * m_flChargeTime))
					m_flChargeTime = 0.0
					m_flChargeAmount = 0.0
				}

				last_fire_time = fire_time
			}

			if ((GetPropInt(self, "m_iReloadMode") == 2) && !m_bInReload)
			{
				m_bInReload = true;

				//if (self.DefaultReload())
				//{
				//	m_bInReload = false
				//}
			}
			else if((GetPropInt(self, "m_iReloadMode") == 0) && m_bInReload)
			{
				m_bInReload = false
			}

			if (owner.GetActiveWeapon() != self)
			{
				m_bInReload = false;
			}


			return -1
		}
		AddThinkToEnt(weapon, "WeaponThink")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
		EntFireByHandle(weapon, "CallScriptFunction", "WeaponThingGiver", 1.5, null, null)
	}

}

::GoldenPanGodly <- function(weapon, player)
{
	weapon.AddAttribute("damage bonus", 4, -1)
}

::RescueRangerFix <- function(weapon, player)
{
	if (weapon.GetClassname() != "tf_weapon_shotgun_building_rescue")
	{
		weapon.AddAttribute("damage bonus", 6.675, -1)

		if( weapon.ValidateScriptScope() )
		{
			local weaponscope = weapon.GetScriptScope()
			weaponscope["WeaponThink"] <- function()	//Our script's name under the weapon scope.
			{
				local owner = self.GetOwner()

				for (local entity; entity = Entities.FindByClassnameNearest("tf_projectile_arrow", weapon.GetOwner().EyePosition(), 999.0);)
				{
					if ((weapon.GetClassname() != "tf_weapon_shotgun_building_rescue") && (GetPropInt(entity, "m_iProjectileType") == 18) && (GetPropEntity(entity, "m_hLauncher") == weapon) && (entity.GetScriptId() != "ClawFixed"))
					{
						SetPropString(entity, "m_iszScriptId", "ClawFixed")
						entity.SetAbsAngles(owner.EyeAngles())
						entity.SetGravity(0.5)
						entity.ApplyAbsVelocityImpulse(owner.EyeAngles().Forward()*2600)
						break;
					}
					else
					{
						break;
					}
				}

				return -1
			}
			AddThinkToEnt(weapon, "WeaponThink")	//After all that's said an done, this adds the think script to handle 'weapon' after it has been validated.
		}
	}
}

m_aWeaponList <- [
	//*
	//NAME,WEAPONMODEL,SKIN,OFFSET
	//scout
	["Scattergun", "models/weapons/c_models/c_scattergun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Force-A-Nature", "models/weapons/c_models/c_double_barrel.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //force a nature
	["Shortstop", "models/workshop/weapons/c_models/c_shortstop/c_shortstop.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //shortstop
	["Soda Popper", "models/workshop/weapons/c_models/c_soda_popper/c_soda_popper.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //soda popper
	["Baby Face's Blaster", "models/workshop/weapons/c_models/c_pep_scattergun/c_pep_scattergun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //Baby Face's Blaster
	["Back Scatter", "models/workshop/weapons/c_models/c_scatterdrum/c_scatterdrum.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //Baby Face's Blaster
	["Pistol", "models/weapons/c_models/c_pistol/c_pistol.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //pistol
	["Bonk! Atomic Punch", "models/weapons/c_models/c_energy_drink/c_energy_drink.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //bonk!
	["Lugermorph", "models/workshop/weapons/c_models/c_ttg_max_gun/c_ttg_max_gun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //lugermorph
	["Crit-a-Cola", "models/weapons/c_models/c_energy_drink/c_energy_drink.mdl", 2 , Vector(0, 0, 0),  null, null, null, Defaults ], //crit a cola
	["Mad Milk", "models/workshop/weapons/c_models/c_madmilk/c_madmilk.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //mad milk
	["Winger", "models/workshop/weapons/c_models/c_winger_pistol/c_winger_pistol.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //winger
	["Pretty Boy's Pocket Pistol", "models/workshop/weapons/c_models/c_pep_pistol/c_pep_pistol.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //PBPP
	["Flying Guillotine", "models/workshop_partner/weapons/c_models/c_sd_cleaver/c_sd_cleaver.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //cleaver duh
	//soldier
	["Rocket Launcher", "models/weapons/c_models/c_rocketlauncher/c_rocketlauncher.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //rocket launcher
	["Direct Hit", "models/weapons/c_models/c_directhit/c_directhit.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //direct hit
	["Black Box", "models/workshop/weapons/c_models/c_blackbox/c_blackbox.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //blackbox
	["Rocket Jumper", "models/weapons/c_models/c_rocketjumper/c_rocketjumper.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //rocket jumper
	["Liberty Launcher", "models/workshop/weapons/c_models/c_liberty_launcher/c_liberty_launcher.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //freedom launcher
	["Cow Mangler 5000", "models/workshop/weapons/c_models/c_drg_cowmangler/c_drg_cowmangler.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //cow mangaler
	["Original", "models/workshop_partner/weapons/c_models/c_bet_rocketlauncher/c_bet_rocketlauncher.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //Original
	["Beggar's Bazooka", "models/workshop/weapons/c_models/c_dumpster_device/c_dumpster_device.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //Beggar's Bazooka
	["Air Strike", "models/workshop/weapons/c_models/c_atom_launcher/c_atom_launcher.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //airstrike
	["Shotgun", "models/weapons/c_models/c_shotgun/c_shotgun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Buff Banner", "models/weapons/c_models/c_buffpack/c_buffpack.mdl", 0 , Vector(16, 0, -64),  null, null, null, Defaults ], //scattergun
	["Battalion's Backup", "models/workshop/weapons/c_models/c_battalion_buffpack/c_battalion_buffpack.mdl", 0 , Vector(16, 0, -64),  null, null, null, Defaults ], //scattergun
	["Concheror", "models/workshop_partner/weapons/c_models/c_shogun_warpack/c_shogun_warpack.mdl", 0 , Vector(16, 0, -64),  null, null, null, Defaults ], //scattergun
	["Reserve Shooter", "models/workshop/weapons/c_models/c_reserve_shooter/c_reserve_shooter.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Righteous Bison", "models/workshop/weapons/c_models/c_drg_righteousbison/c_drg_righteousbison.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Panic Attack", "models/workshop/weapons/c_models/c_trenchgun/c_trenchgun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//Pyro
	["Flamethrower", "models/weapons/c_models/c_flamethrower/c_flamethrower.mdl", 0 , Vector(-20, 0, 0),  null, null, null, Defaults ], //scattergun
	["Backburner", "models/weapons/c_models/c_flamethrower/c_backburner.mdl", 0 , Vector(-20, 0, 0),  null, null, null, Defaults ], //scattergun
	["Degreaser", "models/workshop/weapons/c_models/c_degreaser/c_degreaser.mdl", 0 , Vector(-20, 0, 0),  null, null, null, Defaults ], //scattergun
	["Phlogistinator", "models/workshop/weapons/c_models/c_drg_phlogistinator/c_drg_phlogistinator.mdl", 0 , Vector(-20, 0, 0),  null, null, null, Defaults ], //scattergun
	["Rainblower", "models/weapons/c_models/c_flamethrower/c_flamethrower.mdl", 0 , Vector(-20, 0, 0),  null, null, null, Defaults ], //scattergun
	["Dragon's Fury", "models/weapons/c_models/c_flameball/c_flameball.mdl", 0 , Vector(-20, 0, 0),  null, null, null, Defaults ], //scattergun
	["Nostromo Napalmer", "models/workshop_partner/weapons/c_models/c_ai_flamethrower/c_ai_flamethrower.mdl", 0 , Vector(-20, 0, 0),  null, null, null, Defaults ], //scattergun
	["Flare Gun", "models/weapons/c_models/c_flaregun_pyro/c_flaregun_pyro.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Detonator", "models/workshop/weapons/c_models/c_detonator/c_detonator.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Manmelter", "models/workshop/weapons/c_models/c_drg_manmelter/c_drg_manmelter.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Scorch Shot", "models/workshop/weapons/c_models/c_scorch_shot/c_scorch_shot.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Thermal Thruster", "models/weapons/c_models/c_rocketpack/c_rocketpack.mdl", 0 , Vector(64, 0, 0),  null, null, null, Defaults ], //scattergun
	["Gas Passer", "models/weapons/c_models/c_gascan/c_gascan.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//Demoman
	["Grenade Launcher", "models/weapons/c_models/c_grenadelauncher/c_grenadelauncher.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Loch-n-Load", "models/workshop/weapons/c_models/c_lochnload/c_lochnload.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Loose Cannon", "models/workshop/weapons/c_models/c_demo_cannon/c_demo_cannon.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Iron Bomber", "models/workshop/weapons/c_models/c_quadball/c_quadball.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Stickybomb Launcher", "models/weapons/c_models/c_stickybomb_launcher/c_stickybomb_launcher.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Scottish Resistance", "models/weapons/c_models/c_scottish_resistance/c_scottish_resistance.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Sticky Jumper", "models/weapons/c_models/c_sticky_jumper/c_sticky_jumper.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Quickiebomb Launcher", "models/workshop/weapons/c_models/c_kingmaker_sticky/c_kingmaker_sticky.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//Heavy
	["Minigun", "models/weapons/c_models/c_minigun/c_minigun.mdl", 0 , Vector(-24, 0, 8),  null, null, null, Defaults ], //scattergun
	["Natascha", "models/weapons/c_models/c_minigun/c_minigun_natascha.mdl", 0 , Vector(-24, 0, 8),  null, null, null, Defaults ], //scattergun
	["Iron Curtain", "models/workshop/weapons/c_models/c_iron_curtain/c_iron_curtain.mdl", 0 , Vector(-24, 0, 8),  null, null, null, Defaults ], //scattergun
	["Brass Beast", "models/workshop/weapons/c_models/c_gatling_gun/c_gatling_gun.mdl", 0 , Vector(-24, 0, 8),  null, null, null, Defaults ], //scattergun
	["Tomislav", "models/workshop/weapons/c_models/c_tomislav/c_tomislav.mdl", 0 , Vector(-24, 0, 8),  null, null, null, Defaults ], //scattergun
	["Huo-Long Heater", "models/workshop_partner/weapons/c_models/c_canton/c_canton.mdl", 0 , Vector(-24, 0, 8),  null, null, null, Defaults ], //scattergun
	["Family Business", "models/workshop/weapons/c_models/c_russian_riot/c_russian_riot.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//Engineer
	["Frontier Justice", "models/weapons/c_models/c_frontierjustice/c_frontierjustice.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Widowmaker", "models/workshop_partner/weapons/c_models/c_dex_shotgun/c_dex_shotgun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Pomson 6000", "models/workshop/weapons/c_models/c_drg_pomson/c_drg_pomson.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["RescueRangerFix", "models/workshop/weapons/c_models/c_tele_shotgun/c_tele_shotgun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun

	//Medic
	["Syringe Gun", "models/weapons/c_models/c_syringegun/c_syringegun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Blutsauger", "models/weapons/c_models/c_leechgun/c_leechgun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Crusader's Crossbow", "models/workshop/weapons/c_models/c_crusaders_crossbow/c_crusaders_crossbow.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Overdose", "models/weapons/c_models/c_proto_syringegun/c_proto_syringegun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Medi Gun", "models/weapons/c_models/c_medigun/c_medigun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Kritzkrieg", "models/weapons/c_models/c_medigun/c_medigun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Quick-Fix", "models/weapons/c_models/c_proto_medigun/c_proto_medigun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Vaccinator", "models/workshop/weapons/c_models/c_medigun_defense/c_medigun_defense.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//sniper
	["Sniper Rifle", "models/weapons/c_models/c_sniperrifle/c_sniperrifle.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Huntsman", "models/weapons/c_models/c_bow/c_bow.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Sydney Sleeper", "models/workshop/weapons/c_models/c_sydney_sleeper/c_sydney_sleeper.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Bazaar Bargain", "models/workshop/weapons/c_models/c_bazaar_sniper/c_bazaar_sniper.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Machina", "models/workshop_partner/weapons/c_models/c_dex_sniperrifle/c_dex_sniperrifle.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Hitman's Heatmaker", "models/workshop/weapons/c_models/c_pro_rifle/c_pro_rifle.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["AWPer Hand", "models/weapons/c_models/c_csgo_awp/c_csgo_awp.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Fortified Compound", "models/workshop_partner/weapons/c_models/c_bow_thief/c_bow_thief.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Classic", "models/weapons/c_models/c_tfc_sniperrifle/c_tfc_sniperrifle.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//["Shooting Star", "models/workshop/weapons/c_models/c_invasion_sniperrifle/c_invasion_sniperrifle.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["SMG", "models/weapons/c_models/c_smg/c_smg.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Razorback", "models/player/items/sniper/knife_shield.mdl", 0 , Vector(16, 0, -64),  null, null, null, Defaults ], //scattergun
	["Jarate", "models/weapons/c_models/urinejar.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["DDS", "models/workshop/player/items/sniper/croc_shield/croc_shield.mdl", 0 , Vector(16, 0, -64),  null, null, null, Defaults ], //scattergun
	["Cozy Camper", "models/workshop/player/items/sniper/xms_sniper_commandobackpack/xms_sniper_commandobackpack.mdl", 0 , Vector(16, 0, -64),  null, null, null, Defaults ], //scattergun
	["Cleaner's Carbine", "models/workshop/weapons/c_models/c_pro_smg/c_pro_smg.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//Spy
	["Revolver", "models/weapons/c_models/c_revolver/c_revolver.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Ambassador", "models/weapons/c_models/c_ambassador/c_ambassador.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Big Kill", "models/workshop/weapons/c_models/c_ttg_sam_gun/c_ttg_sam_gun.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["L'Etranger", "models/workshop/weapons/c_models/c_letranger/c_letranger.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Enforcer", "models/workshop/weapons/c_models/c_snub_nose/c_snub_nose.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Diamondback", "models/workshop_partner/weapons/c_models/c_dex_revolver/c_dex_revolver.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Knife", "models/weapons/c_models/c_knife/c_knife.mdl", 0 , Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	["Black Rose", "models/workshop/weapons/c_models/c_ava_roseknife/c_ava_roseknife.mdl", 0, Vector(0, 0, 0),  null, null, null, Defaults ], //scattergun
	//*/
]

//Gets choosen after the fact and very rarely
m_aWeaponListRare <- [
	["GodlyGoldenPan", "models/weapons/c_models/c_frying_pan/c_frying_pan.mdl", 2, Vector(0, 0, 0), null, null, null, Defaults ], //scattergun
	["SentryRocketLauncher", "models/weapons/c_models/c_sentryrocket/c_sentryrocket.mdl", 0, Vector(0, 0, 0), null, null, null, null ], //scattergun
	["TauCannon", "models/workshop/weapons/c_models/c_invasion_sniperrifle/c_invasion_sniperrifle.mdl", 0, Vector(0, 0, 0), null, null, null, null ], //scattergun
]

if ( !( "mysterybox_weapons" in getroottable() ) ) {
	::mysterybox_weapons <- {};

	RegisterCustomWeapon("SentryRocketLauncher", "rocketlauncher", 228,Defaults|WipeAttributes,function (table,player) {table.clipSize = 2,table.clipSizeMax = 2,table.viewModel = "models/weapons/c_models/c_sentryrocket/c_sentryrocket.mdl",table.worldModel = "models/weapons/c_models/c_sentryrocket/c_sentryrocket.mdl"},QuadShooter)
	RegisterCustomWeapon("TauCannon", "pipebomblauncher", 588, Defaults|WipeAttributes,function (table,player) {table.clipSize = 4,table.clipSizeMax = 4,table.ammoType = 2,table.viewModel = "models/workshop/weapons/c_models/c_invasion_sniperrifle/c_invasion_sniperrifle.mdl",table.worldModel = "models/workshop/weapons/c_models/c_invasion_sniperrifle/c_invasion_sniperrifle.mdl"},TauCannon)
	RegisterCustomWeapon("RescueRangerFix", "shotgun_building_rescue", 997, Defaults, function (table,player) {}, RescueRangerFix)
	RegisterCustomWeapon("GodlyGoldenPan", "saxxy", 1071, Defaults, function (table,player) {}, GoldenPanGodly)


	printl("adding custom weapons for the first time");
}

function Precache()
{
    self.PrecacheModel("models/editor/axis_helper.mdl");
	self.PrecacheModel("models/empty.mdl");
	self.PrecacheModel("models/props_trainyard/cart_bomb_separate.mdl");
    self.PrecacheModel("models/props_halloween/merasmus_skull_island.mdl");
    self.PrecacheModel("models/weapons/c_models/c_sentryrocket/c_sentryrocket.mdl");
    self.PrecacheScriptSound("ui/itemcrate_smash_ultrarare_fireworks.wav");
    self.PrecacheScriptSound("ui/item_open_crate_short.wav");
    self.PrecacheScriptSound("Player.Puff");
	m_hFakeProp = CreateProp("prop_dynamic", Mystery_box_weapon_model.GetOrigin(), "models/editor/axis_helper.mdl", 0)
}

function OnPostSpawn()
{
	EntFire( Mystery_box_weapon_model.GetName(), "SetParentAttachment", "1", 1.0,  null );	//
	EntFireByHandle(m_hFakeProp, "SetParent", Mystery_box_model.GetName(), 0.1, null, null);
	EntFireByHandle(m_hFakeProp, "SetParentAttachment", "1", 1.0, null, null);
	//Mystery_box_weapon_model.SetModel("models/weapons/c_models/c_double_barrel.mdl")
	SetPropInt(Mystery_box_weapon_model, "m_takedamage", 0)
	AddThinkToEnt(self, "Think")
	m_hFakeProp.SetModel("models/empty.mdl")
	EntFire("obj_sentrygun", "kill", "", 0.1, null)
}

function ButtonPress()
{
	m_hButtonCaller = activator
	EntFire( Mystery_box_model.GetName(), "SetAnimation", "open_start", 0.0,  null );	//
	EmitSoundEx({
		sound_name = "ui/item_open_crate_short.wav",
		origin = Mystery_box_model.GetCenter(),
		volume = 1.0,
		channel = 6,
		sound_level = 100
	});
	m_flRollingTime = Time() + 5
	m_bEnableRolling = true;
	EntFireByHandle(self, "RunScriptCode", "WeaponSoundAwareded()", 2, null, null);
}

function WeaponSoundAwareded()
{
	DispatchParticleEffect("mvm_pow_gold_seq", Mystery_box_model.GetOrigin() + Vector(0, 0, 48), Vector(90, 0, 0))
	EmitSoundEx({
		sound_name = "ui/itemcrate_smash_ultrarare_fireworks.wav",
		origin = Mystery_box_model.GetCenter(),
		volume = 1.0,
		channel = 6,
		sound_level = 100
	});
}

function WeaponPress()
{
	if (m_hButtonCaller == activator)
	{
		m_bEnableDecay = false
		EntFire( Mystery_box_model.GetName(), "SetAnimation", "open_end", 0.0,  null );	//
		SetPropInt(Mystery_box_weapon_model, "m_takedamage", 0)
		Mystery_box_weapon_model.SetModel("models/empty.mdl")
		EntFireByHandle(Mystery_box_button, "Pressout", "", 4, null, null);
		//m_hButtonCaller.GiveWeapon("Rocket Jumper");
		//(weapon,ItemDefinitionIndex_Override=null,gw_props=Defaults,PostWepFix_Override=null,stats_function_Override=null)
		m_hButtonCaller.GiveWeapon(m_aPickedArray[0], m_aPickedArray[6], m_aPickedArray[7], m_aPickedArray[5], m_aPickedArray[4])
		EntFireByHandle(m_hButtonCaller,"RunScriptCode","self.SaveLoadout()",0.2,m_hButtonCaller,m_hButtonCaller);
		m_hButtonCaller = null
	}
}

function Think()
{
	if(m_bEnableRolling)
	{
		if(m_flRollingTimePickDelay < Time())
		{
			local RandomPick = RandomInt(0, m_aWeaponList.len()-1 );	// pick a gun from the weapon list
			m_aPickedArray = m_aWeaponList[RandomPick];

			Mystery_box_weapon_model.AcceptInput("SetParentAttachment", "1", null,null)
			Mystery_box_weapon_model.SetAbsOrigin(m_hFakeProp.GetOrigin())
			Mystery_box_weapon_model.SetLocalOrigin(m_aPickedArray[3])
			Mystery_box_weapon_model.SetModel(m_aPickedArray[1])
			Mystery_box_weapon_model.SetSkin(m_aPickedArray[2])
			if(m_flRollingTime < Time())
			{
				if (RandomChance(92, 0, 100))
				{
					m_aPickedArray = m_aWeaponListRare[RandomInt(0, m_aWeaponListRare.len() - 1)]

					Mystery_box_weapon_model.SetModel(m_aPickedArray[1])
					Mystery_box_weapon_model.SetSkin(m_aPickedArray[2])
					Mystery_box_weapon_model.SetAbsOrigin(m_hFakeProp.GetOrigin())
					Mystery_box_weapon_model.SetLocalOrigin(m_aPickedArray[3])
				}

				printl(m_iRollingDecel)
				m_bEnableRolling = false;
				SetPropInt(Mystery_box_weapon_model, "m_takedamage", 1)
				m_flDecayTimer = Time() + 16.5
				m_flDecayTimerAnimation = Time() + 12.5
				m_bEnableDecay = true;
				m_bEnableDecayAnimation = true;
				m_iRollingDecel = 0
			}
			m_flRollingTimePickDelay = Time() + RemapVal( m_iRollingDecel,  0,  350,  0.01,  0.25)
		}
		m_iRollingDecel++
	}

	if(m_bEnableDecay)
	{
		if(m_bEnableDecayAnimation)
		{
			if(m_flDecayTimerAnimation < Time())
			{
				m_bEnableDecayAnimation = false
				EntFire( Mystery_box_model.GetName(), "SetAnimation", "open_end", 0,  null );	//
			}
		}

		if(m_flDecayTimer < Time())
		{
			m_bEnableDecay = false;
			m_flDecayTimer = Time()
			m_flRollingTime = Time()
			Mystery_box_weapon_model.SetModel("models/empty.mdl")
			Mystery_box_model.EmitSound("Player.Puff")
			EntFireByHandle(Mystery_box_button, "Pressout", "", 0.5, null, null);
			SetPropInt(Mystery_box_weapon_model, "m_takedamage", 0)
		}
	}
	return -1
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////

    OnGameEvent_post_inventory_application = function(params)
    {
        if (!("userid" in params)) return;
		//Defines player handle as hPlayer
			local hPlayer = GetPlayerFromUserID(params.userid);

		// REQUIRED ( Must be at the beginning! )
			hPlayer.GTFW_Cleanup();	// Anytime a weapon or wearable is created, it won't delete by itself!! This function will remove those entities for you.

			if(!DisableRespawnLoadout)
			{
				EntFireByHandle(hPlayer,"RunScriptCode","self.LoadLoadout()",0.0,hPlayer,hPlayer);
			}

		// - CUSTOM CLASS ARMS FOR FIRST-PERSON
		//	 As it says on the tin. This one is only if you want to restore custom class arms after touching resupply.
		//	 You can set custom arms with function hPlayer.SetCustomClassArms(my_model_path, true)
		//	  If you set param 2 to `true`, it'll save the arms in memory to be loaded by the below function.
		//	  Otherwise, setting to `false` or just not including it won't save it in memory. It'll only last until GTFW_Cleanup() removes it.
			EntFireByHandle(hPlayer,"RunScriptCode","self.GTFW_RestoreCustomClassArms()",0.0,hPlayer,hPlayer);
    }

	OnGameEvent_player_death = function(params)
    {
		if (!("userid" in params)) return;

		//Defines player handle as hPlayer
			local hPlayer = GetPlayerFromUserID(params.userid);
			hPlayer.ValidateScriptScope()
		// Updates ragdoll to the player's actual class.
			GTFW.SetUseClassAnimations_OFF(hPlayer, hPlayer.GetScriptScope(), hPlayer.GetModelName() , hPlayer.GetPlayerClass() )
    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)
